/*****************************************************
Chip type               : ATtiny13
AVR Core Clock frequency: 9,600000 MHz
Memory model            : Tiny
External RAM size       : 0
Data Stack size         : 16
*****************************************************/

#include <tiny13.h>

#define led_on() PORTB.3 = 1
#define led_off() PORTB.3 = 0

#include <delay.h>

unsigned long int voltage;

#define ADC_VREF_TYPE 0x40

// Read the AD conversion result
unsigned long int read_adc(void)
	{
	ADCSRA|=0x40;
	// Wait for the AD conversion to complete
	while ((ADCSRA & 0x10)==0);
	ADCSRA|=0x10;
	return ADCW;
	}

// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port B initialization
// Func5=In Func4=In Func3=Out Func2=In Func1=In Func0=In 
// State5=T State4=T State3=0 State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x08;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=0xFF
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x00;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// External Interrupt(s) initialization
// INT0: Off
// Interrupt on any change on pins PCINT0-5: Off
GIMSK=0x00;
MCUCR=0x00;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
ACSR=0x80;
ADCSRB=0x00;
DIDR0=0x00;

// ADC initialization
// ADC Clock frequency: 600,000 kHz
// ADC Bandgap Voltage Reference: On
// ADC Auto Trigger Source: ADC Stopped
// Digital input buffers on ADC0: On, ADC1: On, ADC2: On, ADC3: On
DIDR0&=0x03;
DIDR0|=0x00;
ADMUX = 0x42;	// REF = 0x40 | ADC_INPUT = 2
ADCSRA=0x84;

// Watchdog Timer initialization
// Watchdog Timer Prescaler: OSC/1024k
// Watchdog Timer interrupt: Off
#pragma optsize-
WDTCR=0x39;
WDTCR=0x29;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

read_adc();
read_adc();
read_adc();
read_adc();
read_adc();
read_adc();

delay_ms(1000);

while (1)
      	{
      	#asm("wdr")
      
      	voltage = (read_adc()+read_adc()+read_adc()+read_adc())*187/4096;
      
      	if (voltage >= 100) 
      		{
                voltage = voltage-100;
                led_on();
                delay_ms(1500);
                led_off();
                delay_ms(500);
                }
        delay_ms(1000);
        if (voltage >= 10)
        	{
                while (voltage >= 10)
                	{
                        voltage = voltage-10;
                        led_on();
                	delay_ms(500);
                	led_off();
                	delay_ms(500);
                        }
                }
        delay_ms(1000);
        if (voltage > 0)
        	{
                while (voltage > 0)
                	{
                        voltage = voltage-1;
                        led_on();
                	delay_ms(200);
                	led_off();
                	delay_ms(300);
                        }
                }
        
        delay_ms(3000);
        
      	}
}
